=== debian/changelog ===
disque (1.0~rc1-5) unstable; urgency=medium

  * Correct SOURCE_DATE_EPOCH patch to invert conditional. Thanks to Reiner
    Herrmann <reiner@reiner-h.de>.
  * Drop explicit pkill now that we have procps.
  * Move to https Vcs-Git URI.

 -- Chris Lamb <lamby@debian.org>  Tue, 02 Feb 2016 10:53:34 +0100

disque (1.0~rc1-4) unstable; urgency=medium

  * Add 0001-SOURCE_DATE_EPOCH.patch to make the build reproducible.

 -- Chris Lamb <lamby@debian.org>  Wed, 06 Jan 2016 11:18:21 +0000

disque (1.0~rc1-3) unstable; urgency=medium

  * Explicitly don't run tests if nocheck is not set.
  * Cleanup test processes; upstream's method for doing this doesn't appear to
    be reliable on buildds. (Closes: #810022)

 -- Chris Lamb <lamby@debian.org>  Tue, 05 Jan 2016 19:46:19 +0000

disque (1.0~rc1-2) unstable; urgency=medium

  * Update debian/copyright after REJECT.

 -- Chris Lamb <lamby@debian.org>  Mon, 04 Jan 2016 17:21:40 +0000

disque (1.0~rc1-1) unstable; urgency=medium

  * New upstream release candidate.
  * Add debian/watch file.

 -- Chris Lamb <lamby@debian.org>  Sat, 02 Jan 2016 19:08:43 +0000

disque (0~git20150911.338561b-2) unstable; urgency=medium

  * Update debian/copyright after REJECT.

 -- Chris Lamb <lamby@debian.org>  Sat, 19 Dec 2015 11:36:09 +0000

disque (0~git20150911.338561b-1) unstable; urgency=medium

  * Initial release. (Closes: #799938)

 -- Chris Lamb <lamby@debian.org>  Sat, 26 Sep 2015 20:57:16 +0200
