=== debian/tests/control ===
Test-Command: disque INFO
