=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/" http://github.com/antirez/disque/releases /(.*).tar.gz
